/**********************************************************************
*                                                                     *
*  dcalc.y: PCYACC grammar description for Simple Calculator          *
*                                                                     *
*  By Y. Jenny Luo                                                    *
*                                                                     *
*  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.          *
*  Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.                   *
*                                                                     *
**********************************************************************/

%{

/**********************************************************************
*                                                                     *
*  dcalc.c: parser for Simple Calculator                              *
*                                                                     *
*  Description: This file is generated by YACC according to the       *
*               grammar description file dcalc.y                      *
*                                                                     *
*  By Y. Jenny Luo                                                    *
*                                                                     *
*  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.          *
*  Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.                   *
*                                                                     *
**********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "public.h"

int zero_flag = 0;      /* flag for divider 0 */

extern void yyerror(char *s, char *t);

extern char result[100];        /*result of expression*/
%}

%union
{
  double db;
  int i;
}


%token          NUMBER

%left           '-' '+'
%left           '*' '/'
%left           '(' ')'
%nonassoc       UMINUS

%start list

%%
list
  : expression  { sprintf(result, "%12g", $$.db); }
  ;

expression
  : expression '+' expression   { $$.db = $1.db + $3.db; }
  | expression '-' expression   { $$.db = $1.db - $3.db; }
  | expression '*' expression   { $$.db = $1.db * $3.db; }
  | expression '/' expression
	{
	  if ($3.db==(double)0)
	    /*yyerror("divided by zero", 0); */
	    zero_flag = 1;
	  else
	    $$.db = $1.db / $3.db;
	}
  | '-' expression                      %prec UMINUS    { $$.db = -$2.db; }
  | '(' expression ')'          { $$.db = $2.db; }
  | NUMBER                      { $$.db = $1.db; } 
  ;

%%
/*--------------------------------------------
  the following macros are supplied
  for compatibility with UNIX yacc
--------------------------------------------*/

#define  yyerrok         yyerrflg=0
#define  yyclearin       if (yytoken==0)  return  1; else  yytoken=-1
#define  YYACCEPT        return (0)
#define  YYABORT         return (1)

#define  YYFLAG          -1000  /* this symbol is required by PCYACC */
#define  YYERROR         goto yyerrlab

#ifndef  YYMAXDEPTH
#define  YYMAXDEPTH      200    /* depth of parser */
#endif

#define YYERRKEY        256
#define YYREDMAX        200


YYSTYPE  yyv[YYMAXDEPTH];                    /* token stack */

int yytoken=-1;                              /* lookahead token */
int yyerrcnt=0;                              /* count of errors */
int yyerrflg=0;                              /* error flag */

